local WololoName		= "cobramonk"

local CVar_EnableWololo = CV_RegisterVar(
    {
        name = "enablewololo",
        defaultvalue = "On",
        flags = CV_NETVAR,
        PossibleValue = CV_YesNo
    }
)

local CVar_ColorSwitchTimer = CV_RegisterVar(
    {
        name = "wololotimer",
        defaultvalue = 5,
        flags = CV_NETVAR,
        PossibleValue = CV_Natural
    }
)

freeslot("sfx_wololo")
sfxinfo[sfx_wololo] = {false, 64}

local function wololo(mobj1, mobj2)
	if CVar_EnableWololo.value == 0 	then return end
	if mobj1.player == nil or mobj2.player == nil then
		return
	end

	if (mobj1.color == mobj2.color) then return end -- don't do wololo on same color targets

	local makeSound = false

	local mobj1color = mobj1.color
	local mobj2color = mobj2.color

	if mobj1.skin == WololoName and
		mobj1.player.kartstuff[k_justbumped] == 0 then

		mobj2.oldColor 	= mobj2.player.skincolor
		mobj2.color 	= mobj1color
		makeSound = true
	end

	if mobj2.skin == WololoName and
		mobj2.player.kartstuff[k_justbumped] == 0 then
			
		mobj1.oldColor 	= mobj1.player.skincolor
		mobj1.color 	= mobj2color
		makeSound = true
	end

	if makeSound == true then
		S_StartSound(wololoPlayer, sfx_wololo)
	end
end

local function wololoTimer(mobj)
	if mobj.oldColor == nil then return end

	mobj.oldColorTimer = mobj.oldColorTimer or CVar_ColorSwitchTimer.value * TICRATE
	mobj.oldColorTimer = $ - 1

	if mobj.oldColorTimer > 0 then return end

	mobj.color			= mobj.oldColor
	S_StartSound(mobj, sfx_s1a4)

	mobj.oldColor		= nil
	mobj.oldColorTimer 	= nil
end

addHook("MobjCollide", wololo, 		MT_PLAYER)
addHook("MobjThinker", wololoTimer, MT_PLAYER)